/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
//usr/share/sugar/activities/TurtleBots.activity/plugins/butia/pybot
package javabot_client;

/**
 *
 * @author Fernanda
 */
import functions.ButiaFunctions;
import java.io.BufferedReader;
import java.io.Console;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import static java.lang.Thread.sleep;
import java.net.Socket;
import java.util.Arrays;
import java.util.List;
import java.util.Scanner;
import java.util.concurrent.Semaphore;
import java.util.logging.Level;
import java.util.logging.Logger;

public class javabot_client {

    static int ERROR = -1;
    static int JAVABOT_PORT = 2009;
    static String JAVABOT_HOST = "localhost";

    private Semaphore lock;
    private String host;
    private int port;
    private Socket client;

    public javabot_client() {
        lock = new Semaphore(1);
        host = JAVABOT_HOST;
        port = JAVABOT_PORT;
        client = null;
        reconnect();

    }
    
    public javabot_client(String server_host, int server_port) {
        lock = new Semaphore(1);
        host = server_host;
        port = server_port;
        client = null;
        reconnect();

    }

    public int reconnect() {
        close();
        try {
            this.client = new Socket(this.host, this.port);

        } catch (IOException e) {
            return ERROR;
        }
        return 0;
    }

    public int close() {
        //close the communication with pybot
        int ret = 0;
        try {
            if(this.client != null){
                this.client.close();
            }            
        } catch (IOException e) {
            ret = ERROR;
        }
        this.client = null;
        return ret;
    }

    public String doCommand(String msg) {
        /* Executes a command in butia.
         @param msg message to be executed*/
        msg = msg + '\n';
        //int ret = ERROR;
        String ret = "";
        try {
            this.lock.acquire();
            DataOutputStream outToServer = new DataOutputStream(client.getOutputStream());
            BufferedReader inFromServer = new BufferedReader(new InputStreamReader(client.getInputStream()));
            outToServer.write(msg.getBytes());
            outToServer.flush();
            
            char[] respuesta = new char[1024];
            inFromServer.read(respuesta);
            //ret = ret[:-1]
            ret = String.valueOf(respuesta);

        } catch (Exception e) {
            ret = "" + ERROR;
            process_error(e);
        }
        this.lock.release();
        ret = ret.replace("\n", "");
        ret = ret.replace("\r", "");
        return ret;
    }

    public void process_error(Exception e) {
        if (client == null || client.isClosed() || !client.isConnected()) {
            this.reconnect();
        }
    }

    public void refresh() {
        /*ask bobot for refresh is state of devices connected*/
        doCommand("REFRESH");
    }

    public String callModule(String modulename, int board_number, int number, String function, String[] Params) {
        //call the modele "modulename"
        String msg = "CALL " + modulename + "@" + board_number + ":" + number + " " + function;
        if (Params != null) {
            int i = 0;
            while (i < Params.length) {
                msg += " " + Params[i];
                i++;
            }
        }
        return doCommand(msg).trim();
    }

    public String closeService() {
        /*Close bobot service*/
        return doCommand("QUIT");
    }

    public int getButiaCount() {
        /*Close bobot service*/
        return Integer.parseInt(doCommand("BUTIA_COUNT"));
    }

    public String[] getModulesList() {
        String ret = doCommand("LIST");
        if (ret.equals("" + ERROR) || ret.equals("")) {
            return null;
        } else {
            return ret.split(",");
        }

    }

    public String[] getListi() {
        return getListi(0);
    }

    public String[] getListi(int board_number) {
        String ret = doCommand("LISTI" + board_number);
        if (ret.equals("" + ERROR) || ret.equals("")) {
            return null;
        } else {
            return ret.split(",");
        }
    }

    public int moduleOpen(String mod) {
        return Integer.parseInt(doCommand("OPEN" + mod));
    }

    public int moduleClose(String mod) {
        return Integer.parseInt(doCommand("CLOSE" + mod));
    }

    public void show_help() {
        System.out.println("Open PyBot client in HOST and PORT.");
        System.out.println("");
        System.out.println("Usage:");
        System.out.println(" javabot_client.py");
        System.out.println(" javabot_client.py [HOST]");
        System.out.println(" javabot_client.py [HOST] [PORT]");
        System.out.println("");
        System.out.println("Default values:");
        System.out.println(" HOST                      localhost");
        System.out.println(" PORT                      2009");
        System.out.println("");
    }
   

}
